/******************************\
*                              *
*      Diochnos Dimitris       *
*          (stud1098)          *
*                              *
*      Saltampassis Nick       *
*          (stud1154)          *
*                              *
********************************
*                              *
*       3 - 5 June 2003        *
*                              *
********************************
*                              *
*          REVISIONS           *
*                              *
* 1] Mar 25, 2008              *
*[vars and comments in English]*
*                              *
* 2] Feb 26, 2009              *
* Inserted assertions to verify*
* that starting ellipsis is not*
* symmetric in all directions. *
*                              *
\******************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*#include <process.h>*/ /* necessary under Win for system () call. */
#include "matrix.h"
#include "prep_defs.h"
#include "power.h"
#include "deflation.h"

#define NO_VIOLATION	1101101
/* 
** Uncomment necessary library above under visual studio. 
** so that the following command works.
*/
/*#define CLEARSCREEN system ( "cls" )*/ 
#define CLEARSCREEN system ( "clear" )

long int L_Computation (MATRIXPTR,MATRIXPTR, const int, const int);
int violated (MATRIXPTR array_A,MATRIXPTR vector_x,MATRIXPTR vector_b,const int constraints, const int variables);
int is_diagonal (MATRIXPTR array);
int		main ()
{
	MATRIXPTR		array_A, M, eigenvectors, productT, new_product;
	MATRIXPTR		product, vector_b, vector_x, a_i, a_iT, a_iTM, a_iTMa_i;
	VECTORPTR		eigenvalues;
	double			temp, temp2, square_root;
	long int		L;
	int				i, j, k, selection = 0;
	int				constraints,variables, violation = 0;
	char			buffer [16];

	while ((selection != 1) && (selection != 2)) {
		CLEARSCREEN;
		/* The old logo that I used with Nick follows.
		**
		printf (" _____________________________________________\n");
		printf ("|                                             |\n");
		printf ("| Dept. of Informatics and Telecommunications |\n");
		printf ("|             University of Athens            |\n");
		printf ("|_____________________________________________|\n");
		printf ("|                                             |\n");
		printf ("|         Dimitris Diochnos (stud1098)        |\n");
		printf ("|         Saltampassis Nick (stud1154)        |\n");
		printf ("|_____________________________________________|\n\n\n");
		**
		*/
		printf (" _____________________________________________\n");
		printf ("|                                             |\n");
		printf ("|  Dimitris Diochnos (diochnos@math.uic.edu)  |\n");
		printf ("|_____________________________________________|\n\n\n");
		printf ("Ellipsoid Algorithm\n");
		printf ("-------------------\n\n");
		printf (" 1. Demo mode.\n");
		printf (" 2. Manual Input.\n");
		printf (" ? ");
		fflush (stdout);
		fflush (stdin);
		scanf ("%d", &selection);
	}

	switch (selection) {
		case 1:
			variables = 2;
			constraints = 2;

			array_A = Initialize_Matrix (constraints, variables);
			Set_Matrix (array_A, 1, 1, -1.0);
			Set_Matrix (array_A, 1, 2, 0.0);
			Set_Matrix (array_A, 2, 1, 0.0);
			Set_Matrix (array_A, 2, 2, -1.0);

			vector_b = Initialize_Matrix (constraints, 1);
			Set_Matrix (vector_b, 1, 1, (double) 0.0-1.0);
			Set_Matrix (vector_b, 2, 1, (double) 0.0-1.0);
			break;

		case 2:
			CLEARSCREEN;
			printf ("Please insert number of constraints: ");
			scanf("%d",&constraints);
			printf("Please insert number of variables: ");
			scanf("%d",&variables);

			array_A = Initialize_Matrix (constraints, variables);
			vector_b = Initialize_Matrix (constraints, 1);

			CLEARSCREEN;
			printf("Please insert the coefficients of inequalities:\n");
			for(i=0;i<constraints;i++){
				for(j=0;j<variables;j++){
					printf("Give me a[%d,%d]:",i+1,j+1);
					scanf ("%lf", &temp);
					Set_Matrix (array_A, i+1, j+1, temp);
				}
			}

			CLEARSCREEN;
			printf("Please give me vector b:\n");
			for(i=0;i<constraints;i++){
				printf("Give me b[%d]:",i+1);
				scanf("%lf",&temp);
				Set_Matrix (vector_b,i+1,1,temp);
			}
			break;

		default:
			/* It will never enter here ... :p */
			printf ("\n * Severe errors in your mind!\a\n\n");
			break;
	}

	CLEARSCREEN;
	printf ("\n\nEntering Ellipsoid Algorithm...\n");
	printf ("\n*********************************\n\n");

	eigenvalues = Initialize_Vector (variables);
	eigenvectors = Initialize_Matrix (variables, variables);
	L = L_Computation (array_A, vector_b, constraints, variables);

	printf ("The length of the input is L = %ld\n", L);
	printf ("\n*********************************\n\n");

	vector_x = Initialize_Matrix (variables, 1);
	product = Initialize_Matrix (variables, 1);
	M = Initialize_Matrix (variables, variables);
	for (i = 1; i <= variables; i++)
		Set_Matrix (M, i, i, (double) (pow (2, L) + ((double) (i - 1))));

	Print_Matrix (vector_x, "Vector X");
	Print_Matrix (M, "Matrix M");

	/* Eigenvalues and Eigenvectors */
	if(!is_diagonal(M)){
		Deflation (M, DEFAULT_TOLERANCE, DEFAULT_MAX_ITERATIONS, eigenvalues, eigenvectors);

		for (i = 1; i <= eigenvalues->size; i++)
			printf ("Eigenvalue %d: %.8f \n", i, eigenvalues->column [i - 1]);
		printf ("\n");


		for (i = 1; i <= eigenvectors->size; i++) {
			for (j = 1; j <= eigenvectors->size; j++) {
				printf ("%+.8f  ", eigenvectors->line [i - 1]->column [j - 1]);
			}
			printf ("\n");
		}
	}
	else{
		//printf ("Your system requires precision which is not available. Now exiting.\n");
		//exit (1);
		Get_Matrix (M,1,1,&temp);
		for (i = 1; i <= M->size; i++) {
			Set_Vector (eigenvalues, i, temp);
			printf ("Eigenvalue %d: %.8f \n", i, temp );
		}
		printf ("\n");
		
		for (i = 1; i <= eigenvectors->size; i++) {
			for (j = 1; j <= eigenvectors->size; j++) {
				if (i == j)
					Set_Matrix (eigenvectors, i, j, 1.0);
				else
					Set_Matrix (eigenvectors, i, j, 0.0);
				printf ("%+.8f  ", eigenvectors->line [i - 1]->column [j - 1]);
			}
			printf ("\n");
		}
	}

	printf ("\nInitial Center: <");
	for (i = 0; i < vector_x->size - 1; i++)
		printf ("%.2f, ", vector_x->line [i]->column [1]);
	printf ("%.2f>\n\n", vector_x->line [i]->column [vector_x->size - 1]);
	fflush (stdout);
	fflush (stdin);
	printf ("Press ENTER key to continue ...");
	fflush (stdout);
	fflush (stdin);
	fgets (buffer, sizeof (buffer) - 1, stdin);
	printf ("\n*********************************\n\n");


	new_product = Initialize_Matrix (variables, variables);
	for (k = 0; k <= (int) ((double) 6 * pow ((variables + 1), 2) * L); k++) {				
		violation = violated (array_A, vector_x, vector_b,constraints, variables);
		if (violation == NO_VIOLATION)
			break;
		printf ("Violated inequality: %d\n\n", violation + 1);
		a_i = Initialize_Matrix (variables, 1);
		a_iT = Initialize_Matrix (1, variables);
		for (i = 1; i <= variables; i++){
			Get_Matrix (array_A, violation + 1, i, &temp);
			Set_Matrix (a_i, i, 1, temp);
			Set_Matrix (a_iT, 1, i, temp);
		}
		
		Multiplication_Matrices (M, a_i, product);

		productT = Initialize_Matrix (1, variables);
		for (i = 1; i <= variables; i++) {
			Get_Matrix (product, i, 1, &temp);
			Set_Matrix (productT, 1, i, temp);
		}
		
		a_iTM = Initialize_Matrix (1, variables);
		a_iTMa_i = Initialize_Matrix (1, 1);
		Multiplication_Matrices (a_iT, M, a_iTM);
		Multiplication_Matrices (a_iTM, a_i, a_iTMa_i);
		Get_Matrix (a_iTMa_i, 1, 1, &temp);
		square_root = sqrt (temp);

		for(j=0;j<variables;j++){
			Get_Matrix (vector_x,j+1, 1, &temp);
			Get_Matrix (product, j+1, 1, &temp2);
			Set_Matrix (vector_x,j+1, 1, (double) (temp-temp2/(square_root*(variables+1))));
		}
		Print_Matrix (vector_x, "Vector X");
		/* END OF X */
		
		Multiplication_Matrices (product, productT, new_product);

		for (i = 1; i <= variables; i++) {
			for (j = 1; j <= variables; j++) {
				Get_Matrix (new_product, i, j, &temp);
				Get_Matrix (a_iTMa_i, 1, 1, &temp2);
				Set_Matrix (new_product, i, j, 2*temp/((variables + 1)*temp2));
				Get_Matrix (M, i, j, &temp);
				Get_Matrix (new_product, i, j, &temp2);
				Set_Matrix (M, i, j, (temp - temp2)*pow(variables, 2) / (pow (variables, 2) - 1));
			}
		}

		Print_Matrix (M, "Matrix M");

		/* Eigenvalues and Eigenvectors */	
		if(!is_diagonal(M)){
			Deflation (M, DEFAULT_TOLERANCE, DEFAULT_MAX_ITERATIONS, eigenvalues, eigenvectors);

			for (i = 1; i <= eigenvalues->size; i++)
				printf ("Eigenvalue %d: %.8f \n", i, eigenvalues->column [i - 1]);
			printf ("\n");


			for (i = 1; i <= eigenvectors->size; i++) {
				for (j = 1; j <= eigenvectors->size; j++) {
					printf ("%+.8f  ", eigenvectors->line [i - 1]->column [j - 1]);
				}
				printf ("\n");
			}
		}
		else{
			Get_Matrix (M,1,1,&temp);
			for (i = 1; i <= M->size; i++) {
				Set_Vector (eigenvalues, i, temp);
				printf ("Eigenvalue %d: %.8f \n", i, temp );
			}
			printf ("\n");

			for (i = 1; i <= eigenvectors->size; i++) {
				for (j = 1; j <= eigenvectors->size; j++) {
					if (i == j)
						Set_Matrix (eigenvectors, i, j, 1.0);
					else
						Set_Matrix (eigenvectors, i, j, 0.0);
					printf ("%+.8f  ", eigenvectors->line [i - 1]->column [j - 1]);
				}
				printf ("\n");
			}
		}
		printf ("\nNew Center: <");
		for (i = 0; i < vector_x->size - 1; i++) {
			Get_Matrix (vector_x, i+1, 1, &temp);
			printf ("%.2f, ", temp);
		}
		Get_Matrix (vector_x, vector_x->size, 1, &temp);
		printf ("%.2f>\n\n", temp);
		fflush (stdout);
		fflush (stdin);
		printf ("Press ENTER key to continue ...");
		fflush (stdout);
		fflush (stdin);
		fgets (buffer, sizeof (buffer) - 1, stdin);
		printf ("\n*********************************\n\n");
	}

	

	if (violation == NO_VIOLATION){
		printf ("Successful termination!\n");
		printf ("The center of the last ellipsis lies in the feasible region.\n");
		printf ("Consult the results of the previous step.\n");
	}
	else
		printf ("FAIL\a\a\a\a\a\a!\n");
		
	Destroy_Matrix (M);
	Destroy_Matrix (array_A);
	Destroy_Matrix (eigenvectors);
	Destroy_Matrix (product);
	Destroy_Matrix (vector_b);
	Destroy_Matrix (vector_x);
	Destroy_Vector (eigenvalues);

	return	0;
}

long int L_Computation (MATRIXPTR array_A,MATRIXPTR vector_b, const int constraints, const int variables){
	double s1 = (double) 0.0, s2 = (double) 0.0, temp;
	int i,j;

	for(i=0;i<constraints;i++) {
		for(j=0;j<variables;j++) {
			Get_Matrix(array_A,i+1,j+1,&temp);
			s1 += ceil((double) log( fabs(temp) + 1)/log(2));
		}
	}
	for(i=0;i<constraints;i++) {
		Get_Matrix (vector_b, i, 1, &temp);
		s2 += ceil(log(fabs(temp)+1)/log(2));
	}

	return	((long int) (ceil(log(constraints)/log(2)) + ceil(log(variables)/log(2)) + s1 + s2 + constraints*(variables+1)));
}

int violated (MATRIXPTR array_A,MATRIXPTR vector_x,MATRIXPTR vector_b,const int constraints, const int variables){
	int			i, j;
	double		temp, temp2;
	MATRIXPTR	res, temp_array;
	
	temp_array = Initialize_Matrix (1, variables);
	res = Initialize_Matrix (1, 1);
	for(i=0;i<constraints;i++){
		temp_array = Initialize_Matrix (1, variables);
		res = Initialize_Matrix (1, 1);
		for (j = 1; j <= variables; j++) {
			Get_Matrix (array_A, i+1, j, &temp);
			Set_Matrix (temp_array, 1, j, temp);
		}
		Multiplication_Matrices (temp_array,vector_x,res);
		Get_Matrix (vector_b,i+1,1,&temp);
		Get_Matrix (res,1,1,&temp2);
		if(temp2>=temp) {
			Destroy_Matrix (temp_array);
			Destroy_Matrix (res);
			return i;
		}
	}

	Destroy_Matrix (temp_array);
	Destroy_Matrix (res);

	return NO_VIOLATION;

}

int is_diagonal(MATRIXPTR array){
	int i,j;
	double	temp, a11;
	int const size = array->size;

	/* For debugging purposes, uncomment ALL 3 printf statements below. */

	Get_Matrix (array,1,1,&a11);
	for (i = 2; i<=size; i++) {
		Get_Matrix (array,i,i,&temp);
		if(temp != a11) {
			/*printf ("Element (%d, %d) is different from a[1][1].\n", i, i);*/
			return 0;
		}
	}
	for(i=1; i<=size; i++){
		for(j=1; j<=size; j++){
			if(i!=j){
				Get_Matrix (array,i,j,&temp);
				if(temp != (double) 0.0) {
					/*printf ("Element (%d, %d) is non-zero.\n", i, j);*/
					return 0;
				}
			}
		}
	}

	/*printf ("Given matrix is diagonal.\n");*/

	return 1;
}

