/******************************\
*                              *
*      Diochnos Dimitris       *
*          (stud1098)          *
*                              *
*      Saltampassis Nick       *
*          (stud1154)          *
*                              *
********************************
*                              *
*       3 - 5 June 2003        *
*                              *
********************************
*                              *
*          REVISIONS           *
*                              *
* 1] Mar 25, 2008              *
*[vars and comments in English]*
*                              *
* 2] Feb 26, 2009              *
* Inserted assertions to verify*
* that starting ellipsis is not*
* symmetric in all directions. *
*                              *
\******************************/

#ifndef MATRIX_H
#define MATRIX_H

/*
** ! Note: The arrays begin at index number 1 and NOT at index 0.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Preproccessor Directives */
#define OK										1
#define	SET_NOT_INITIALIZED_VECTOR				-1
#define SET_VECTOR_OUT_OF_BOUNDS				-2
#define	GET_NOT_INITIALIZED_VECTOR				-3
#define GET_VECTOR_OUT_OF_BOUNDS				-4
#define SET_NOT_INITIALIZED_MATRIX				-5
#define SET_MATRIX_OUT_OF_BOUNDS				-6
#define GET_NOT_INITIALIZED_MATRIX				-7
#define GET_MATRIX_OUT_OF_BOUNDS				-8
#define SWAP_LINES_OUT_OF_BOUNDS				-9
#define SWAP_COLUMNS_VECTOR_OUT_OF_BOUNDS		-10
#define SWAP_COLUMNS_MATRIX_OUT_OF_BOUNDS		-11
#define GET_COLUMN_MATRIX_UNDEFINED				-12
#define GET_COLUMN_MATRIX_OUT_OF_BOUNDS			-13
#define GET_COLUMN_MATRIX_INCOMPATIBLE_TYPES	-14
#define SET_COLUMN_MATRIX_UNDEFINED				-15
#define SET_COLUMN_MATRIX_OUT_OF_BOUNDS			-16
#define SET_COLUMN_MATRIX_INCOMPATIBLE_TYPES	-17

/* Data Structures */
struct vector {
	double	* column;
	int		size;
};

typedef struct vector VECTOR;
typedef VECTOR * VECTORPTR;

struct matrix {
	VECTORPTR	* line;
	int			size;
};

typedef struct matrix MATRIX;
typedef MATRIX * MATRIXPTR;

/*
** Functions for manipulation of arrays.
*/

VECTORPTR	Initialize_Vector (const int);
void		Destroy_Vector (VECTORPTR);
int			Set_Vector (VECTORPTR, const int, const double);
int			Get_Vector (VECTORPTR, const int, double *);
int			Swap_Columns_Vector (VECTORPTR, const int, const int);
void		Multiplication_Vectors (VECTORPTR, VECTORPTR, double *);
MATRIXPTR	Initialize_Matrix (const int, const int);
void		Destroy_Matrix (MATRIXPTR);
int			Set_Matrix (MATRIXPTR, const int, const int, const double);
int			Get_Matrix (MATRIXPTR, const int, const int, double *);
int 		Swap_Lines (MATRIXPTR, const int, const int);
int			Swap_Columns_Matrix (MATRIXPTR, const int, const int);
void		Multiplication_Matrices (MATRIXPTR, MATRIXPTR, MATRIXPTR);
void		Multiplication_Matrix_Vector (MATRIXPTR, VECTORPTR, VECTORPTR);
int			Get_Column (MATRIXPTR, const int, VECTORPTR);
int			Set_Column (MATRIXPTR, const int, VECTORPTR);
void		Print_Matrix (MATRIXPTR, char *);

#endif
